package 
{
	import away3d.containers.View3D;
	import away3d.lights.PointLight;
	import away3d.materials.ColorMaterial;
	import away3d.primitives.Cube;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	import away3d.debug.AwayStats;
	
	/**
	 * Show me da cube
	 * @author Abiyasa
	 */
	public class Main extends Sprite 
	{
		private var _view:View3D;
		private var _cube:Cube;
		private var _light:PointLight;
		
		public function Main():void 
		{
			// init view
			_view = new View3D();
			_view.backgroundColor = 0xDDDDDD;
			this.addChild(_view);			
			
			// add away3d debugger
			addChild(new AwayStats(_view));
			
			// init light
			_light = new PointLight();
			_light.x = 0; 
			_light.y = -1000;
			_light.z = -1000;
			_light.color = 0xFFFFFF;			
			
			_view.scene.addChild(_light);
			
			// create cube with simple color material
			var material:ColorMaterial = new ColorMaterial(0x009EE1);
			material.lights = [ _light ];
			_cube = new Cube(material, 100, 100, 100, 4, 4, 4);
			_cube.y = 150;
			_view.scene.addChild(_cube);
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			stage.addEventListener(Event.RESIZE, onStageResize);
			
			// add event listener
			this.addEventListener(Event.ENTER_FRAME, handleEnterFrame, false, 0, true);
		}
		
		private function onStageResize(event:Event):void
		{
			_view.width = stage.stageWidth;
			_view.height = stage.stageHeight;
		}
		
		private function handleEnterFrame(event:Event):void
		{
			// rotate the cube
			_cube.rotationY += 5;
			_view.render();
		}		
	}
	
}